Subject: Re: [mobile-ip] MH Checksum calculation

From: Jari Arkko <[email-masked]>
Date: Tue, 06 Aug 2002 14:47:26 +0300

Brian Haley wrote:

> Seems like Jari must be back from vacation with all the recent emails :)

I wasn't back then, but now I am...

> Anyways, I think the Checksum calculation paragraph in Section 6.1.1
> needs some clarification.  The pseudo IPv6 header used does not specify
> which source address is used if there is a Home Address Option in the
> packet.  Some MH types do not require HAO (HoTI,CoTI, etc.), one
> might have one (BRR, if MN->MN), and others must have one (BU).
> I'm assuming that if there's a HAO, that it must be used as the IPv6
> source address for the checksum calculation?  If so, in addition to 6.1.1

Right.

> changes, it might be good to add some text (in 11.2.1?) that says what
> a MN should do if sending a MH message with a HAO.
> 
> Section 11.2.1 does do a good job of saying how a MN should send
> a "direct delivery" packet, swapping addresses and such, but doesn't
> mention checksum.

Checksum calculation should be the same for MH as it is for ICMP etc.
My suggestion is to clarify this in 11.2.1 as follows:

      -  Construct the packet using the mobile node's home address
         as the packet's Source Address, in the same way as if the
         mobile node were at home. NEW=> This includes the calculation
         of upper layer checksums using the home address as the value
         of the source.

and then refer to this from 6.1.1 as follows:

         Note that the procedures described in Section 11.2.1 apply
         even for the Mobility Header. If a Mobility Header message
         has a Home Address destination option, then the checksum calculation
         uses the address in this option as the value of the IPv6 Source
         Address field.

Jari

---

From: Brian Haley <[email-masked]>
Date: Tue, 06 Aug 2002 09:56:05 -0400

>          uses the address in this option as the value of the IPv6 Source

This sounds good to me, thanks Jari.

-Brian